# coding: utf-8
import sys
from tkinter import *
from imagecanvas import *


#■メディアンフィルタ
def median():
    NX=len(cbit.ID)
    NY=len(cbit.ID[0])
    DX=int(NX/20)   # "フィルタ処理中"を表示する間隔
    K=1
    for i in range(1,NX-1):
        if (i % DX)==0:
            root.title("メディアン・フィルタ処理中"+"■"*K)
            K+=1
        for j in range(1,NY-1):
            Filter=[]
            for k1 in range(-1,2): #着目点と周辺のカラーを取り出す(合計9個)
                for k2 in range(-1,2):
                    Filter.append(cbit.Canvas.itemcget(cbit.ID[i+k1][j+k2],option='fill'))
            for k1 in range(5): # 中央値(5番目(k1 = 4)の大きさの値)を選択する。
                mindt=Filter[k1]
                minID=k1
                for k2 in range(k1+1,9):
                    if mindt>Filter[k2]:
                        mindt=Filter[k2]
                        minID=k2
                Filter[minID]=Filter[k1]  #　最小値部分に先頭の値を代入(交換不要)
            cbit.Canvas.itemconfig(cbit.ID[i][j],fill=mindt) # k1 = 4のときの最小値が中央値
    root.update()
    root.title("メディアン・フィルタ処理完了")                

#■ウィンドウが閉じられるときの処理
def exitProc():
    if messagebox.askokcancel("終了","終了してもよろしいですか?"):
        root.destroy()
        sys.exit()
#■メイン処理   
root = Tk()
root.geometry("600x500")
root.title("メディアン・フィルタ処理")
FT=[('BMPファイルlファイル','*.bmp;*.*')]
filename=filedialog.askopenfilename(filetypes=FT)
if filename!="":
    root.title("ビットマップ読込み中")
    bitmap=readBitmap(filename)
    if bitmap!=[]:
        #準備処理
        root.title("キャンバス準備中")
        canvas=Canvas(root,width=bitmap.info.width,height=bitmap.info.height)
        canvas.place(x=0,y=30)
        canvas2=Canvas(root,width=bitmap.info.width,height=bitmap.info.height)
        canvas2.place(x=bitmap.info.width,y=30)
        root.title("ビットマップ表示中")
        cbit=drawBitmap(canvas, bitmap)
        root.update()
        root.title("元画像ビットマップ表示中")
        c2=drawBitmap(canvas2, bitmap)
        root.update()
        
        #(注意)メディアン・フィルタの場合、R・G・Bに分解する処理は不要なので
        #      以下2行の処理を行わない。
        #root.title("ビットマップリスト準備中")
        #tmp=getRGBList(cbit)
        root.title("メディアン・フィルタ処理")
        
        #ラベルの宣言
        label1 = Label(root, text='処理後', fg='black')
        label1.place(x=10, y=2)
        label2 = Label(root, text='元画像', fg='black')
        label2.place(x=bitmap.info.width+10, y=2)
        #ボタンの宣言                        
        button1 = Button(root, text='終了', command=exitProc)
        button1.place(x=400, y=400)
        button2 = Button(root, text='メディアン・フィルタ', command=median)
        button2.place(x=10, y=400)
        
        #メインループ("WM_DELETE_WINDOW"が届いたときexitProcを呼び出す)
        root.protocol("WM_DELETE_WINDOW",exitProc)
        root.mainloop()
root.destroy()
sys.exit()
        
